package com.sun.xml.internal.ws.api.model.wsdl.editable;

import com.sun.xml.internal.ws.api.model.wsdl.WSDLPortType;
import com.sun.xml.internal.ws.api.model.wsdl.WSDLBoundPortType;
import com.sun.xml.internal.ws.api.model.wsdl.WSDLService;
import com.sun.xml.internal.ws.api.model.wsdl.WSDLMessage;
import com.sun.xml.internal.ws.policy.PolicyMap;
import java.util.Map;
import com.sun.istack.internal.NotNull;
import javax.xml.namespace.QName;
import com.sun.xml.internal.ws.api.model.wsdl.WSDLModel;

public interface EditableWSDLModel extends WSDLModel
{
    public abstract EditableWSDLPortType getPortType(@NotNull QName p0);
    
    public abstract void addBinding(EditableWSDLBoundPortType p0);
    
    public abstract EditableWSDLBoundPortType getBinding(@NotNull QName p0);
    
    public abstract EditableWSDLBoundPortType getBinding(@NotNull QName p0, @NotNull QName p1);
    
    public abstract EditableWSDLService getService(@NotNull QName p0);
    
    @NotNull
    public abstract Map<QName, ? extends EditableWSDLMessage> getMessages();
    
    public abstract void addMessage(EditableWSDLMessage p0);
    
    @NotNull
    public abstract Map<QName, ? extends EditableWSDLPortType> getPortTypes();
    
    public abstract void addPortType(EditableWSDLPortType p0);
    
    @NotNull
    public abstract Map<QName, ? extends EditableWSDLBoundPortType> getBindings();
    
    @NotNull
    public abstract Map<QName, ? extends EditableWSDLService> getServices();
    
    public abstract void addService(EditableWSDLService p0);
    
    public abstract EditableWSDLMessage getMessage(QName p0);
    
    @Deprecated
    public abstract void setPolicyMap(PolicyMap p0);
    
    public abstract void finalizeRpcLitBinding(EditableWSDLBoundPortType p0);
    
    public abstract void freeze();
}
